﻿using System.Collections.Generic;
using System.Linq;
using System.Text;
using NModel.Conformance;
using NModel.Terms;

using RealUser = System.String;
using ModelUser = System.String;
using OrchardMode;

namespace Orchard.Test
{
    public class Stepper : IStepper
    {
        private TestLibrary TestSettings { get; set; }

        public string wrongPassword;
        public Dictionary<ModelUser, RealUser> modelUserToRealUser;
        public Dictionary<RealUser, string> realUserPassword;

        public Stepper()
        {
        }

        private void Initialize()
        {
            TestSettings = TestLibrary.SetupTest();
        }

        #region IStepper Members

        public CompoundTerm DoAction(CompoundTerm action)
        {
            switch (action.Name)
            {
                case "Initialize":
                    Initialize();
                    break;

                case "Login_Start":
                    string userName;
                    // modelUserToRealUser.TryGetValue((string)((CompoundTerm)action[0])[0], out userName);
                    modelUserToRealUser.TryGetValue((string)((CompoundTerm)action.Arguments[0])[0], out userName);
                    string userPass = string.Empty;
                    switch ((string)((CompoundTerm)action.Arguments[1])[0])
                    {
                        case "Correct":
                            userPass = realUserPassword[userName];
                            break;

                        case "Incorrect":
                            userPass = wrongPassword;
                            break;
                    }

                    TestSettings.UserHelper.LogOn(userName, userPass);
                    var status = LoginStatus.Success;
                    if (TestSettings.UserHelper.IsLoginFaled())
                        status = LoginStatus.Failure;

                    return Action.Create("Login_Finish", action.Arguments[0], status);

                case "Logout":
                    TestSettings.UserHelper.LogOff();
                    break;

                case "CreateBlog":
                    TestSettings.BlogHelper.CreateRandomBlog();
                    break;

                case "DeleteBlog":
                    break;
            }

            return null;
        }

        public void Reset()
        {
            TestSettings.Shutdown();
            TestSettings = TestLibrary.SetupTest();
        }

        #endregion
    }
}
