﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NModel.Attributes;
using NModel;

namespace OrchardMode
{
    [Feature("AdminSite")]
    public class Admin
    {
        private static int m_nextId = 1;
        // private static Map<User, Set<Blog>> m_allBlogs = Map<User, Set<Blog>>.EmptyMap;
        private static Set<Blog> m_allBlogs = Set<Blog>.EmptySet;
        private static Map<User, Blog> m_blogsMap = Map<User, Blog>.EmptyMap;

        private static Set<Blog> NextBlog()
        {
            return new Set<Blog>(new Blog(m_nextId));
        }

        [Action]
        public static void CreateBlog(User user, [Domain("NextBlog")]Blog blog)
        {
            m_nextId = m_nextId + 1;
            m_blogsMap = m_blogsMap.Add(user, blog);
            m_allBlogs = m_allBlogs.Add(blog);
            //if (m_allBlogs.Contains(user))
            //{
            //    var blogs = m_allBlogs[user];
            //    blogs = blogs.Add(blog);
            //    m_allBlogs = m_allBlogs.Add(user, blog);
            //}
            //else
            //{
            //    m_allBlogs = m_allBlogs.Add(user, new Set<Blog>(blog));
            //}
        }

        public static bool CreateBlogEnabled()
        {
            return WebSiteModel.State != ModeState.Initializing;
        }

        public static bool CreateBlogEnabled(User user)
        {
            return WebSiteModel.UsersLoggedIn.Contains(user) && (int)user > (int)User.Anonymous;
        }

        public static bool CreateBlogEnabled(User user, Blog blog)
        {
            // return !m_blogsMap.ContainsKey(user) || m_blogsMap[user].Id != blog.Id;
            return !m_blogsMap.ContainsKey(user);
        }

        //[Action]
        //public static void DeleteBlog(User user, [Domain("m_allBlogs")]Blog blog)
        //{
        //    m_blogsMap = m_blogsMap.Remove(new Pair<User, Blog>(user, blog));
        //    m_allBlogs = m_allBlogs.Remove(blog);
        //}

        //public static bool DeleteBlogEnabled()
        //{
        //    return WebSiteModel.State != ModeState.Initializing;
        //}

        //public static bool DeleteBlogEnabled(User user)
        //{
        //    return WebSiteModel.UsersLoggedIn.Contains(user);
        //}

        //public static bool DeleteBlogEnabled(User user, Blog blog)
        //{
        //    return m_blogsMap.ContainsKey(user) &&
        //        m_blogsMap[user] == blog;
        //}
    }
}
