﻿using System;
using NModel.Attributes;
using NModel.Terms;
using NModel.Execution;
using NModel;

namespace OrchardMode
{
    public enum ModeState { Initializing, Running }

    public enum User { Anonymous, Authenticated, Author, Administrator }

    public class WebSiteModel
    {
        public static ModeState State = ModeState.Initializing;

        public static ModelProgram CreateLoginModel()
        {
            return new LibraryModelProgram(typeof(WebSiteModel).Assembly,
                "OrchardMode", new Set<string>("Login"));
        }

        public static ModelProgram CreateAdminModel()
        {
            return new LibraryModelProgram(typeof(WebSiteModel).Assembly,
                "OrchardMode", new Set<string>("Login", "AdminSite"));
        }

        [Action]
        public static void Initialize()
        {
            State = ModeState.Running;
        }

        public static bool InitializeEnabled() { return State == ModeState.Initializing; }

        public static Set<User> UsersLoggedIn = Set<User>.EmptySet;
    }
}
